Spinner and progress in Angular Progress Button

14 Aug 202611 minutes to read

Change spinner position

Spinner position can be changed by modifying the position property of spinSettingsModel. By default, the spinner is positioned at the left of the ProgressButton. You can position it at the left, right, top, bottom, or center of the text content.

Change spinner size

Spinner size can be changed by modifying the width property of spinSettingsModel. In this demo, the width is set to 20 to change the spinner size.

Spinner template

You can use custom spinner by specifying the template property of spinSettingsModel with custom styles.

The following sample demonstrates the above functionalities of the spinner.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ProgressButtonModule } from '@syncfusion/ej2-angular-splitbuttons'



import { Component } from '@angular/core';
import { SpinSettingsModel } from '@syncfusion/ej2-angular-splitbuttons';

@Component({
imports: [
        
        ProgressButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
                <!-- To render progress button. -->
               <button ejs-progressbutton content='Submit' [spinSettings]='spinSettings'></button></div>`
})

export class AppComponent {
    public spinSettings : SpinSettingsModel = { position: 'Right', width: 20, template: '<div class="template"></div>'  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Progress

Content animation

The content of the ProgressButton can be animated during progress using the effect property of animationSettingsModel. You can also set custom duration and timing function using the duration and easing properties. The possible effect values are None, SlideLeft, SlideRight, SlideUp, SlideDown, ZoomIn, and ZoomOut.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ProgressButtonModule } from '@syncfusion/ej2-angular-splitbuttons'



import { Component } from '@angular/core';
import { SpinSettingsModel, AnimationSettingsModel } from '@syncfusion/ej2-angular-splitbuttons';

@Component({
imports: [
        
        ProgressButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
                <button ejs-progressbutton content='Slide Left' [enableProgress]='true' [animationSettings]= 'animationSettings' [spinSettings]='spinSettings'></button></div>`
})

export class AppComponent {
    public spinSettings : SpinSettingsModel = { position: 'Center' };
    public animationSettings : AnimationSettingsModel = { effect:'SlideLeft', duration: 500, easing: 'linear' };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Change step of the ProgressButton

The progress can be visualized at the specified interval by changing the step property in the begin event of the ProgressButton. In this demo, the step property is set to 20 to show progress at every 20% increment.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ProgressButtonModule } from '@syncfusion/ej2-angular-splitbuttons'



import { Component } from '@angular/core';
import { ProgressEventArgs } from '@syncfusion/ej2-angular-splitbuttons';

@Component({
imports: [
        
        ProgressButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
                <button ejs-progressbutton content='Progress Step' [enableProgress]='true' (begin)='begin($event)' cssClass='e-hide-spinner'></button></div>`
})

export class AppComponent {
    public begin(args: ProgressEventArgs): void {
        args.step = 20;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The class e-hide-spinner hides the spinner in the ProgressButton, For more information, see hide spinner section.

Change progress dynamically

The progress can be changed dynamically by modifying the percent property in the ProgressButton events. In this demo, on 40% completion of progress, the percent property is set to 90 to show dynamic change of the progress.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ProgressButtonModule } from '@syncfusion/ej2-angular-splitbuttons'



import { Component } from '@angular/core';
import { ProgressEventArgs } from '@syncfusion/ej2-angular-splitbuttons';

@Component({
imports: [
        
        ProgressButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
                <button ejs-progressbutton [content]='content' [enableProgress]='true' [duration]='15000' (begin)='begin($event)' (progress)='progress($event)' (end)='end($event)' cssClass='e-hide-spinner'></button></div>`
})

export class AppComponent {
    public content: string = 'Progress';

    public begin(args: ProgressEventArgs): void {
        this.content = 'Progress ' + args.percent + '%';
    }

    public progress(args: ProgressEventArgs): void {
        this.content = 'Progress ' + args.percent + '%';
        if (args.percent === 40) {
            args.percent = 90;
        }
    }

    public end(args: ProgressEventArgs): void {
        this.content = 'Progress ' + args.percent + '%';
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The method dataBind applies the property changes immediately to the component.

Start and stop methods

You can pause and resume the progress using the stop and start methods, respectively. In this demo, clicking the ProgressButton will pause and resume the progress.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ProgressButtonModule } from '@syncfusion/ej2-angular-splitbuttons'



import { Component, ViewChild } from '@angular/core';
import { ProgressButtonComponent } from '@syncfusion/ej2-angular-splitbuttons';

@Component({
imports: [
        
        ProgressButtonModule
    ],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
                <button #progressBtn ejs-progressbutton [content]='content' [enableProgress]='true' [duration]='4000' (end)='end()' [iconCss]='iconCss' cssClass='e-hide-spinner' (click)="btnClick()"></button></div>`
})

export class AppComponent {
    @ViewChild('progressBtn')
    public progressBtn : ProgressButtonComponent | any;
    public content: string = 'Download';
    public iconCss: string = 'e-btn-sb-icon e-download';

    public end(): void {
        this.content = 'Download';
        this.iconCss = 'e-btn-sb-icon e-download';
    }

    public btnClick(): void {
        if(this.content === 'Download') {
            this.content = 'Pause';
            this.iconCss = 'e-btn-sb-icon e-pause';
        }
        else if(this.content === 'Pause') {
            this.content = 'Resume';
            this.iconCss = 'e-btn-sb-icon e-play';
            this.progressBtn.stop();
        }
        else if(this.content === 'Resume') {
            this.content = 'Pause';
            this.iconCss = 'e-btn-sb-icon e-pause';
            this.progressBtn.start();
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also

Spinner and progress in React Progress Button

Spinner

Control the appearance and behavior of the animated spinner indicator shown during progress operations.

Change spinner position

Customize the spinner’s location relative to button content by modifying the position property in spinSettingsModel. By default, the spinner appears on the left side of the button text. Reposition it to left, right, top, bottom, or center based on your layout preferences.

Change spinner size

Adjust the spinner dimensions by modifying the width property in spinSettingsModel. This allows you to scale the spinner icon up or down to match your button size and visual hierarchy. In the demo below, the width is set to 20 pixels to create a smaller spinner.

Spinner template

Create a custom spinner design by specifying the template property in spinSettingsModel. Use HTML or SVG markup with custom CSS styles to replace the default animated spinner with your own branded animation or icon.

The following sample demonstrates the above functionalities of the spinner.

import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';
function App() {
    let spinSettings = { position: 'Right', width: 20, template: '<div class="template"></div>' };
    return (<ProgressButtonComponent content='Submit' spinSettings={spinSettings}/>);
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));
import { ProgressButtonComponent, SpinSettingsModel } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';

function App() {

  let spinSettings : SpinSettingsModel = { position: 'Right', width: 20, template: '<div class="template"></div>' };

  return (
    <ProgressButtonComponent content='Submit' spinSettings={spinSettings}/>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));

Progress

Visual progress indicators and animations provide feedback during long-running operations.

Content animation

Animate the React Progress Button text or content during progress operations using the effect property in animationSettingsModel. Control animation timing with the duration and easing properties.

Available animation effects are:

  • None - No animation
  • SlideLeft - Content slides from right to left
  • SlideRight - Content slides from left to right
  • SlideUp - Content slides upward
  • SlideDown - Content slides downward
  • ZoomIn - Content scales up (zooms in)
  • ZoomOut - Content scales down (zooms out)
import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';
function App() {
    let animationSettings = { effect: 'SlideLeft', duration: 500, easing: 'linear' };
    let spinSettings = { position: 'Center' };
    return (<ProgressButtonComponent content='Slide Left' enableProgress={true} animationSettings={animationSettings} spinSettings={spinSettings}/>);
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));
import { AnimationSettingsModel, ProgressButtonComponent, SpinSettingsModel } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';

function App() {

  let animationSettings: AnimationSettingsModel = { effect: 'SlideLeft',  duration: 500, easing: 'linear' };
  let spinSettings : SpinSettingsModel = { position: 'Center' };

  return (
    <ProgressButtonComponent content='Slide Left' enableProgress = {true} animationSettings={animationSettings} spinSettings={spinSettings}/>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));

Change step of the React Progress Button

Control the granularity of progress visualization by modifying the step property in the begin event. The step value determines how much the progress bar advances on each update. For example, setting step to 20 displays progress in 5% increments (100 ÷ 20), creating a smooth visual progression for the user.

import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';
function App() {
    function begin(args) {
        args.step = 20;
    }
    return (<ProgressButtonComponent content='Progress Step' enableProgress={true} begin={begin} cssClass='e-hide-spinner'/>);
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));
import { ProgressButtonComponent, ProgressEventArgs } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';

function App() {

  function begin(args: ProgressEventArgs): void {
      args.step = 20;
  }

  return (
    <ProgressButtonComponent content='Progress Step' enableProgress = {true} begin={begin} cssClass='e-hide-spinner'/>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));

The class e-hide-spinner hides the spinner in the React Progress Button, For more information, see hide spinner section.

Change progress dynamically

Update the progress percentage in real-time by modifying the percent property during React Progress Button events. This technique enables conditional progress adjustments based on application logic. For example, you can jump the progress to 90% when a particular milestone is reached at 40% completion, allowing for non-linear progress visualization.

import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import { useState } from "react";
import * as React from 'react';
import * as ReactDom from 'react-dom';
function App() {
    const [state, setState] = useState({
        content: 'Progress'
    });
    return (<ProgressButtonComponent content={state.content} enableProgress={true} duration={15000} begin={begin} progress={progress} end={end} cssClass='e-hide-spinner'/>);
    function begin(args) {
        setState({ content: 'Progress ' + args.percent + '%' });
    }
    function progress(args) {
        setState({ content: 'Progress ' + args.percent + '%' });
        if (args.percent === 40) {
            args.percent = 90;
        }
    }
    function end(args) {
        setState({ content: 'Progress ' + args.percent + '%' });
    }
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));
import { ProgressButtonComponent, ProgressEventArgs } from '@syncfusion/ej2-react-splitbuttons';
import { useState } from "react";
import * as React from 'react';
import * as ReactDom from 'react-dom';

function App() {
  const [state, setState] = useState({
    content: 'Progress'
  });

    return (
      <ProgressButtonComponent content={state.content} enableProgress = {true} duration={15000} begin={begin} progress={progress} end={end} cssClass='e-hide-spinner'/>
    );

  function begin(args: ProgressEventArgs): void {
    setState({ content: 'Progress ' + args.percent + '%' });
  }

  function progress(args: ProgressEventArgs): void {
    setState({ content: 'Progress ' + args.percent + '%' });
    if (args.percent === 40) {
      args.percent = 90;
    }
  }

  function end(args: ProgressEventArgs): void {
    setState({ content: 'Progress ' + args.percent + '%' });
  }
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));

The method dataBind applies the property changes immediately to the component.

Start and stop methods

Control progress playback by invoking the start and stop methods. Use these methods to pause long-running operations or allow users to resume interrupted tasks. In the example below, clicking the React Progress Button toggles between paused and active states.

import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useState } from "react";
function App() {
    let progressBtn;
    const [state, setState] = useState({
        content: 'Download',
        iconCss: 'e-btn-sb-icon e-download'
    });
    return (<ProgressButtonComponent content={state.content} enableProgress={true} duration={4000} iconCss={state.iconCss} end={end} cssClass='e-hide-spinner' onClick={clickHandler} ref={(scope) => { progressBtn = scope; }} />);
    function end() {
        setState({ content: 'Download', iconCss: 'e-btn-sb-icon e-download' });
    }
    function clickHandler() {
        if (state.content === 'Download') {
            setState({ content: 'Pause', iconCss: 'e-btn-sb-icon e-pause' });
        }
        else if (state.content === 'Pause') {
            setState({ content: 'Resume', iconCss: 'e-btn-sb-icon e-play' });
            progressBtn.stop();
        }
        else if (state.content === 'Resume') {
            setState({ content: 'Pause', iconCss: 'e-btn-sb-icon e-pause' });
            progressBtn.start();
        }
    }
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));
import { ProgressButtonComponent } from '@syncfusion/ej2-react-splitbuttons';
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useState } from "react";

function App() {
  let progressBtn: ProgressButtonComponent;
  const [state, setState] = useState({
    content: 'Download',
    iconCss: 'e-btn-sb-icon e-download'
  });

  return (
    <ProgressButtonComponent content={state.content} enableProgress={true} duration={4000}
      iconCss={state.iconCss} end={end} cssClass='e-hide-spinner' onClick={clickHandler} ref={(scope) => { progressBtn = scope as ProgressButtonComponent; }} />
  );

  function end(): void {
    setState({ content: 'Download', iconCss: 'e-btn-sb-icon e-download' });
  }

  function clickHandler(): void {
    if (state.content === 'Download') {
      setState({ content: 'Pause', iconCss: 'e-btn-sb-icon e-pause' });
    }
    else if (state.content === 'Pause') {
      setState({ content: 'Resume', iconCss: 'e-btn-sb-icon e-play' });
      progressBtn.stop();
    }
    else if (state.content === 'Resume') {
      setState({ content: 'Pause', iconCss: 'e-btn-sb-icon e-pause' });
      progressBtn.start();
    }
  }
}
export default App;
ReactDom.render(<App />, document.getElementById('progress-button'));

See Also